﻿Type=Class
Version=5.9
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
' Class module
Sub Class_Globals
	'Dim ABM As ABMaterial
	Dim ABMComp As ABMCustomComponent
	Private FrappeEventName As String
	Private FrappeChartType As String ' can be bar, line, scatter, pie, percentage
	Public FrappeLabels As List
	Private FrappeTitle As String
	Private FrappeDataSets As List
	Private FrappeSpecialValues As List
	Private FrappeHeight As Int
	' tick, span
	Public FrappeXAxisMode As String = "span"
	' tick, span
	Public FrappeYAxisMode As String = "span"
	' to allow skipping of X values
	Public FrappeIsSeries As Boolean
	
	Public FrappeRaiseEventOnClick As Boolean
	Public FrappeIsNavigable As Boolean
	
	Public FrappeShowSums As Boolean
	Public FrappeShowAverages As Boolean
	
	' SPECIFIC LINE PROPERTIES
	Public FrappeLineShowDots As Boolean = True
	Public FrappeLineHeatline As Boolean
	Public FrappeLineRegionFill As Boolean
	
	' In BuildPage(), add the js
	' page.AddExtraJavaScriptFile("custom/frappe-charts.min.iife.js")	
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, ChartType As String, ChartTitle As String, HeightPx As Int)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID, "")
	FrappeChartType = ChartType
	FrappeTitle = ChartTitle
	FrappeHeight = HeightPx
	FrappeEventName = ID.ToLowerCase
	FrappeDataSets.Initialize
	FrappeLabels.Initialize
	FrappeSpecialValues.Initialize	
	' the automatic events will be raised on the page e.g. if the id = "mycomp" then the event will be mycomp_Click(params as Map)
End Sub

'colors: 'green', 'blue', 'violet', 'red', 'orange', 'yellow', 'light-blue', 'light-green', 'purple', 'magenta', 'grey', 'dark-grey'
public Sub AddDataSet(Title As String, Color As String, Values As List, formattedValues As List)
	Dim ValueStr As String = "["
	For i = 0 To Values.Size - 1
		If i > 0 Then
			ValueStr = ValueStr & ","
		End If
		ValueStr = ValueStr & Values.Get(i)
	Next
	ValueStr = ValueStr & "]"
	Dim formattedValueStr As String = "["
	For i = 0 To formattedValues.Size - 1
		If i > 0 Then
			formattedValueStr = formattedValueStr & ","
		End If
		formattedValueStr = formattedValueStr & Chr(34) & formattedValues.Get(i) & Chr(34)
	Next
	formattedValueStr = formattedValueStr & "]"
	Dim data As String
	If formattedValues.size > 0 Then
		data = $"{title: "${Title}", color:"${Color}", values: ${ValueStr}, formatted: ${formattedValueStr}}"$
	Else
		data = $"{title: "${Title}", color:"${Color}", values: ${ValueStr}}"$
	End If
	FrappeDataSets.Add(data)
End Sub

' LineType: deshed, solid
public Sub AddSpecialValue(Title As String, LineType As String, Value As Double)
	FrappeSpecialValues.Add($"{title:"${Title}", line_type: "${LineType}", value: ${Value}}"$)
End Sub


' runs when an object is created for the first time. Expects a valid html string
' will get surrounded by a div automatically
' in the html file:
'<div ID="mycomp" class="">
'    <h1 ID="testh1">This Is a test</h1>
'</div>
Sub ABMComp_Build(InternalPage As ABMPage, internalID As String) As String
	Return $"<div id="${internalID}"></div>var _${internalID};"$
End Sub

' Is useful to run some initalisation script. 
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Dim data As String = $"{labels: ["$
	For i = 0 To FrappeLabels.Size - 1
		If i > 0 Then
			data = data & ","
		End If
		data = data & $""${FrappeLabels.Get(i)}""$
	Next
	data = data & "], datasets: ["
	For i = 0 To FrappeDataSets.Size - 1
		If i > 0 Then
			data = data & ","
		End If
		data = data & FrappeDataSets.Get(i)
	Next
	data = data & "]"
	Dim SpecificValues As String
	If FrappeSpecialValues.Size > 0 Then
		SpecificValues = "data.specific_values = ["
		For i = 0 To FrappeSpecialValues.Size - 1
			If i > 0 Then
				SpecificValues = SpecificValues & ","
			End If
			SpecificValues = SpecificValues & FrappeSpecialValues.Get(i)
		Next
		SpecificValues = SpecificValues & "];"
	End If
	data = data & "}"
	Dim script As String = $"let data = ${data};${SpecificValues}let _${internalID}=new Chart({parent: "#${internalID}", title: "${FrappeTitle}", data: data, type: '${FrappeChartType}', height: ${FrappeHeight},"$
	If FrappeIsNavigable Then
		script = script & "is_navigable: 1,"
	Else
		script = script & "is_navigable: 0,"
	End If
	If FrappeChartType = "line" Then
		If FrappeLineShowDots Then
			script = script & "show_dots: 1,"
		Else
			script = script & "show_dots: 0,"
		End If	
		If FrappeLineHeatline Then
			script = script & "heatline: 1,"
		Else
			script = script & "heatline: 0,"			
		End If
		If FrappeLineRegionFill Then
			script = script & "region_fill: 1,"
		Else
			script = script & "region_fill: 0,"
		End If
	End If
	script = script & $"x_axis_mode: '${FrappeXAxisMode}',"$
	script = script & $"y_axis_mode: '${FrappeYAxisMode}',"$
	If FrappeIsSeries Then
		script = script & $"is_series: 1"$
	Else
		script = script & $"is_series: 0"$
	End If
	script = script & "});"
	If FrappeShowSums Then
		script = script & $"_${internalID}.show_sums();"$
	End If
	If FrappeShowAverages Then
		script = script & $"_${internalID}.show_averages();"$
	End If
	If FrappeRaiseEventOnClick Then
		script = script & $"_${internalID}.parent.addEventListener('data-select', (e) => {b4j_raiseEvent('page_parseevent', {'eventname': '${FrappeEventName}' + '_clicked','eventparams': 'index', 'index': e.index});});"$
	End If
	InternalPage.ws.Eval(script, Array As Object(ABMComp.ID))
	' flush not needed, it's done in the refresh method in the lib
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	' use these methods to adjust the object
	' ABM.HasClass
	' ABM.AddClass
	' ABM.RemoveClass
	
	' ABM.AddHTML
	' ABM.InsertHTMLAfter
	' ABM.RemoveHTML
	
	' ABM.GetProperty
	' ABM.SetProperty
	' ABM.RemoveProperty
	
	' ABM.GetStyleProperty
	' ABM.SetStyleProperty
	
	' do some script stuff like you do in RunJavaScript
	
	'Dim script As String = $""$
	'InternalPage.ws.Eval(script, Null)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
	
End Sub




